from ..interfaces import FightingEntity


class Player(FightingEntity):
    name = "player"
    maxhealth: int = 20
    strength: int = 5
    intelligence: int = 1
    charisma: int = 1
    dexterity: int = 1
    constitution: int = 1
    level: int = 1
    current_xp: int = 0
    max_xp: int = 10

    def move(self, y: int, x: int) -> None:
        """
        When the player moves, move the camera of the map.
        """
        super().move(y, x)
        self.map.currenty = y
        self.map.currentx = x

    def move_up(self) -> bool:
        return self.check_move(self.y - 1, self.x, True)

    def move_down(self) -> bool:
        return self.check_move(self.y + 1, self.x, True)

    def move_left(self) -> bool:
        return self.check_move(self.y, self.x - 1, True)

    def move_right(self) -> bool:
        return self.check_move(self.y, self.x + 1, True)

    def level_up(self) -> None:
        while self.current_xp > self.max_xp:
            self.level += 1
            self.current_xp -= self.max_xp
            self.max_xp = self.level * 10

    def add_xp(self, xp: int) -> None:
        self.current_xp += xp
        self.level_up()
